boolean start = true; 
boolean game = false;
boolean rules = false; 
int h = 800; 
int w = 400; 
float speed; 
PImage lane;
PImage car;
int score;
int carpos = 233;
PImage stone;
int delay; 
ArrayList<Barrier> barriers;
boolean game_over;
int save_score;


void setup() {
  size(800, 800);
  frameRate(30);
  lane = loadImage("road_0.png");
  car = loadImage("car.png");
  stone = loadImage("stone.png");
  reset();
}


void reset() {
  speed = 15;
  score = 0;
  save_score = 0;
  delay = int(random(15, 60));
  barriers = new ArrayList<Barrier>();
}


class Barrier {
  PVector pos; // The position of the barrier, upper left  
  float v; // The speed at which the barrier moves
  PVector size;
  
  Barrier(float x, float y, float w, float h) {
    pos = new PVector(x, y);
    this.v = speed;
    this.size = new PVector(w, h);
  }
  
  void display() {
    image(stone, pos.x, pos.y, size.x, size.y); // Display the image at the current position
  }
  
  void move() {
    pos.y += speed; // Move the barrier downwards
  }
  
  boolean collidesWith() {
    int carx = carpos + 15;
    if (this.pos.x + this.size.x >= carx && this.pos.x <= carx + 60) {
      // Check if the rectangles overlap in the y-axis
      if (this.pos.y + this.size.y >= 400 && this.pos.y <= 550) {
        // The rectangles are colliding
        return true;
      }
    }
    return false;
  }
}




void draw() {
  if (start) {
    start_screen();
  } else if (game_over) {
    game_over();
  } else if (game) {
    game_screen();
  } else if (rules) {
    rules_screen();
  } 
}


void start_screen() {
  background(100);
  
  fill(255, 0, 0); 
  rect(300, 375, 70, 70); 
  rect(720, 50, 30, 30); 
  
  fill(255); 
  textSize(22); 
  text("Rules", 710, 100);
  textSize(40);
  text("Play!", 380, 420);
  
  if (mousePressed) {
    if (mouseX >= 300 && mouseX <= 370 && mouseY >= 375 && mouseY <= 445) {
      game = true;
      start = false;
    }
    if (mouseX >= 720 && mouseX <= 750 && mouseY >= 50 && mouseY <= 80) {
      rules = true;
      start = false;
    }
  }
}


void game_screen() {
  background(100);
  image(lane, 200, 0, 400, 800);
  image(car, carpos, 400, 90, 150);
  
  fill(252, 190, 3);
  textSize(50);
  text("Score:", 640, 50);
  textSize(50);
  text(str(score), 640, 100);
  
  fill(255, 0, 0);
  rect(615, 700, 170, 85);
  fill(0);
  textSize(50);
  text("Close", 642, 760);
  
  fill(252, 190, 3);
  rect(15, 15, 170, 85);
  fill(0);
  textSize(50);
  text("Reset", 42, 73);
  
  

  if (keyPressed) {
    if (key == 'a' || key == 'A') {
      carpos -= 10;
    }
    if (key == 'd' || key == 'D') {
      carpos += 10;
    }
    /*if (key == 'g') {
      print(mouseX);
      print(' ');
    }*/
    save_score = score;

  
 if (mousePressed) {
      if (mouseX >= 615 && mouseX <= 785 && mouseY >= 700 && mouseY <= 785) {
        game = false;
        start = true;
        reset();
      }
      if (mouseX >= 15 && mouseX <= 185 && mouseY >= 15 && mouseY <= 100) {
        reset();
      }
    }
 
 if (carpos > 494) {
   carpos = 494;
 } else if (carpos < 219) {
   carpos = 219;
 }
  
  
  }
  
  
  
  /*fill(255, 0, 0);
  rect(carpos + 15, 400, 10, 10); 
  rect(carpos + 75, 400, 10, 10); */
  if (delay <= score) {
    delay += int(random(15, 60));
    random_barrier();
  }
  
  for (Barrier b : barriers) {
    b.display();
    b.move();
    if (b.collidesWith()) {
      game_over = true;   
    }
  }
  
  score++; 
}


void game_over() {
  background(100);
  fill(255, 0, 0);
  textSize(40);
  text("Game over! Press Space to try again.", 100, 400);
  text("Your score was:  " + score, 230, 500);
  if (keyPressed) {
    if (key == ' ') {
      game_over = false;
      reset();
    }
  }
}


void rules_screen() {
  background(100);
  
  fill(255, 0, 0);
  rect(615, 700, 170, 85);
  fill(0);
  textSize(50);
  //textAlign(LEFT);
  text("Close", 642, 760);
  
  fill(252, 190, 3);
  textSize(30);
  //textAlign(CENTER);
  text("The rules of the game:", 250, 110);
  text("Player moves the car to the left and right", 150, 170);
  text("The goal is to get the maximum possible score", 120, 230);
  text("If the car collides with a stone,", 210, 290);
  text("the game ends and you have to start it again.", 120, 350);
  text("There is no end, so you can play until you collide", 100, 410);
  
  
  
  if (mousePressed) {
    if (mouseX >= 615 && mouseX <= 785 && mouseY >= 700 && mouseY <= 785) {
      rules = false;
      start = true;
      reset();
    }
  }
  
  
  
}



void random_barrier() {
    float bw = random(10, 100);
    float bh = random(10, 100);
    float bx = random(200, 600 - bw);
    float by = 0;
    Barrier b = new Barrier(bx, by, bw, bh);
    barriers.add(b);
}
